<?php /* Modified at 1 places by ri_once */ ?>
<?php /* 'php' Added by ri_once */


// This file contains the functions that will run when somebody changes something 
function rwSpamFile($spamfile,$type,$entry,$value){
	global $sadc,$saPref;

// global variable to remove wl/bl entries if a "*@catchall" was found
// and there are existing entries for that domain
// 0 = dont remove
// 1 = remove from same side
// 2 = remove from both sides
// $saPref[1] = "1";
if(!$saPref[1]){ $saPref[1] = $sadc[wrm]; }
if(!$sadc[wrm]){ $saPref[1] = 0; }

// Define some stuff to make lookups easier
$list = array('rh' => 'required_hits',
              'rs' => 'rewrite_subject',
              'st' => 'subject_tag',
              'dm' => 'defang_mime',
              'tr' => 'use_terse_report',
              'wl' => 'whitelist_from',
              'bl' => 'blacklist_from',
              'sc' => 'score',
             );

// Reverse matching on emails
$alt = array('bl' => 'whitelist_from',
             'wl' => 'blacklist_from',
             );

// Output message
$message = array('bl' => 'Blacklist%20Update',
		 'wl' => 'Whitelist%20Update',
		 'gen' => 'General%20Options%20Update',
		 'sc' => 'Score%20Update',
		 'remove' => 'Removal%20of%20Selected%20Entries',
		);

// Now we need to build a list of current entries
$read = file($spamfile, "r");
$gen[rh] = array_values(preg_grep("/^required_hits+(\s+)/", $read));
$gen[rs] = array_values(preg_grep("/^rewrite_subject+(\s+)/", $read));
$gen[st] = array_values(preg_grep("/^subject_tag+(\s+)/", $read));
$gen[dm] = array_values(preg_grep("/^defang_mime+(\s+)/", $read));
$gen[tr] = array_values(preg_grep("/^use_terse_report+(\s+)/", $read));
$wl = array_values(preg_grep("/^whitelist_from+(\s+)+([.-\w]|\*|()+\@[A-Za-z0-9]+[-A-Za-z0-9.]+\.[A-Za-z0-9]+)/", $read));
$bl = array_values(preg_grep("/^blacklist_from+(\s+)+([.-\w]|\*|()+\@[A-Za-z0-9]+[-A-Za-z0-9.]+\.[A-Za-z0-9]+)/", $read));
$sc = array_values(preg_grep("/^score+(\s+)+([\w])+(\s+)+(()|(-)+[0-9.0-9])/", $read));



// This seems to take over no matter what you do
// Just in case something screws up in our general options we will get updated
#if(!preg_match("/^required_hits+(\s+)+(([0-9]+).([0-9]+))/", $gen[rh])){$gen[rh] = array("required_hits\t$sadc[rh]\n"); }
if(!$gen[rh]){$gen[rh] = array("required_hits\t$sadc[rh]\n"); }
#if(!preg_match("/^rewrite_subject+(\s+)+(0|1)/", $gen[rs])){$gen[rs] = array("rewrite_subject\t$sadc[rws]\n"); }
if(!$gen[rs]){$gen[rs] = array("rewrite_subject\t$sadc[rws]\n"); }
#if(!preg_match("/^subject_tag(\s+)+([[:print:]])/", $gen[st][0])){$gen[st] = array("subject_tag\t$sadc[st]\n"); }
if(!$gen[st]){$gen[st] = array("subject_tag\t$sadc[st]\n"); }
#if(!preg_match("/^defang_mime(\s+)(0|1)/", $gen[dm])){$gen[dm] = array("defang_mime\t$sadc[dm]\n"); }
if(!$gen[dm]){$gen[dm] = array("defang_mime\t$sadc[dm]\n"); }
#if(!preg_match("/^use_terse_report(\s+)(0|1)/", $gen[tr])){$gen[tr] = array("use_terse_report\t$sadc[tr]\n"); }
if(!$gen[tr]){$gen[tr] = array("use_terse_report\t$sadc[tr]\n"); }

$tl = array();
foreach($bl as $_){ array_push($tl, "$_"); }
foreach($wl as $_){ array_push($tl, "$_"); }

// Do our matching on the General options
if($type == 'gen'){


// Use for testing
#if(!$entry[rh]){$entry[rh] = "9.9";}
#if(!$entry[rs]){$entry[rs] = "yes";}

$cgen = $entry;
$ans = array('yes' => '1', 'no' => '0',); // Conversion for yes/no

#$blank_rh = split("required_hits",$gen[rh][0]);
#$blank_rs = split("subject_tag",$gen[rh][0]);
#$blank_rh = preg_split('/(\s+)/', $gen[rh][0], 2, PREG_SPLIT_NO_EMPTY);
#echo $blank_rh[1];
#exit;

// Sanity checks
if($cgen[rh]){if(preg_match("/([a-zA-Z])/", $cgen[rh])){ $error .= "Required Hits must be a number (Ex: 5.05)"; }
	      elseif(!preg_match("/^([0-9])/", $cgen[rh])){ $error .= "Required Hits must start with a number (Ex: 5.05)"; } 
	      elseif($cgen[rh] < $sadc[mrh]){ $error .= "Required Hits can not be below $sadc[mrh]"; }
	      elseif($cgen[rh] > $sadc[xrh]){ $error .= "Required Hits can not be above $sadc[xrh]"; }
	      else {} 
	     }

if($cgen[rs]){if(!preg_match("/^(yes|no)$/", $cgen[rs])){ $error .= "Rewrite Subject can be yes or no only"; }}
if($cgen[dm]){if(!preg_match("/^(yes|no)$/", $cgen[dm])){ $error .= "Defang Mime can be yes or no only"; }}
if($cgen[tr]){if(!preg_match("/^(yes|no)$/", $cgen[tr])){ $error .= "Terse Report can be yes or no only"; }}
// End sanity checks


if(!$error){
if($cgen[rh]){ $cgen[rh] = sprintf("%.2f", $cgen[rh]); }
$gkey = array_keys($cgen);
foreach($gkey as $_){
  if($cgen[$_]){
        $val = $cgen[$_];
        if($_ == 'rs' || $_ == 'dm' || $_ == 'tr'){ $out = $ans[$val]; }
        else { $out = $val; }
$gen[$_] = preg_replace("/^$list[$_]+(\s+)+([[:print:]]+)/","$list[$_]\t$out", $gen[$_]);
                }
                    }
	    }

// Use this for testing
#$i=1;
#foreach($gen as $_){echo "$i: $_[0]<br>"; $i++; }
#exit;
		  }// End General

// Do our matching on the whitelist or blacklist

elseif($type == wl || $type == bl){
$entry = trim($entry); // strip all whitespace before/after
$entry = str_replace(' ', '', "$entry"); // Just in case remove whitespace inside email
$entry = str_replace(',', '.', "$entry"); // Change a comma to a dot
$entry = preg_replace("/^()@/", '*@', $entry); // Make sure we get a * in front of an @
$e_ = str_replace("*", "\*", $entry);

// Make an attempt to validate an email layout
#if(!preg_match("/([.*-\w])@+([.-\w])+\.+([.-\w])/", $e_)){
if(!preg_match("/([.*-\w])@+([.-\w])|([*])+\.+([.-\w])/", $e_)){
	$error = "Not a valid email address";
						       }

/*
// Full domain check not functional yet, would have to rewrite the entire
// checking system to get it to work, which is quite big right now
// Maybe an added feature in the 2.x series
*/

    // Match found do nothing
    elseif(sizeof(preg_grep("/^$list[$type](\s+)+$e_\$/i", $tl))  == "1"){
        $error = "Entry Already On List"; }

    // Found on other side replace
    elseif(sizeof(preg_grep("/^$alt[$type](\s+)+$e_\$/", $tl))  == "1"){
        $tl = preg_replace("/^$alt[$type](\s+)+$e_/", "$list[$type]\t$entry", array_values($tl));
                                                                           }
    // New Entry
    else{
        //New Entry
        array_push($tl, "$list[$type]\t$entry\n");
        }
			 }


// Do our matching on the scores
elseif($type == 'sc'){
 if(!$value){$value = 0; }
 if(preg_match("/([[:alpha:]])/", $value)){ $error = "Score must be a numberic value only"; }

if(!$error){
  $v = sprintf("%.2f", $value);
  $e = strtoupper($entry);

  if(sizeof(preg_grep("/^$list[$type](\s+)$e(\s+)$v/",$sc)) == "1"){ $error  = "Select Different Value for  $e"; }
  elseif(sizeof(preg_grep("/^$list[$type](\s+)+$e+(\s+)+(()|(-))([0-9].[0-9])/", $sc)) == "1"){
	$sc = preg_replace("/^$list[$type](\s+)+$e+(\s+)+(()|(-))([0-9].[0-9][0-9])/", "$list[$type]\t$e\t$v", array_values($sc));
								   }
  else{ array_push($sc, "score\t$e\t$v\n"); }

	   }

		     }// End score match


// So far this removes everything and does not work
elseif($type == "remove"){
 if(!$value){ $error = "Improper Removal Code"; }
 if(!$entry){ $error = "Nothing Selected for Removal"; }

 if(!$error){
   foreach($entry as $_){
	if($value == 'wlbl'){
	  $_ = str_replace("*", "\*", $_);
	  $tl = preg_replace("/^((whitelist_from|blacklist_from))+(\s+)$_/", "", array_values($tl));
			      }

	if($value == 'sc'){
	  #$sc = preg_replace("/^score(\s+)+$_+(\s+)+(()|(-))(([0-9]+).[0-9][0-9])/", "", array_values($sc));
	  $sc = preg_replace("/^score(\s+)+$_+(\s+)+(()|(-))(([0-9]+).([0-9]+))/", "", array_values($sc));
			  }

			}
	    } // End no error

			  } // End remove type
	  
	   

// Do nothing but report error
else{ $error = "Undefined Type"; }


// Lets see if we want to rewrite our file
if(!$error){
sort($tl);
sort($sc);

$fp = @fopen("$spamfile", "w+");
      fwrite($fp, "\n\n#General Options\n");
      foreach($gen as $_){ fwrite($fp, $_[0]); }
      fwrite($fp, "\n\n#Blacklist/Whitelist Entries\n");
      foreach($tl as $_){ $_ = preg_replace("/^\n$/", "", $_); fwrite($fp, $_); }
      fwrite($fp, "\n\n#Configured Rules\n");
      foreach($sc as $_){ $_ = preg_replace("/^\n$/", "", $_); fwrite($fp, $_); }
fclose($fp);

$error = "$message[$type]%20Successful";
	     }

return $error;


					}//End Function


?>
